using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using Terraria.ID;
using Terraria.ModLoader;
 
namespace JoshuasMod.Items.Weapons.CosmicCataclysm        //We need this to basically indicate the folder where it is to be read from, so you the texture will load correctly.
{
    public class CosmicCataclysm : ModItem
    {
        public override void SetDefaults()
        {
			item.CloneDefaults(ItemID.StarWrath);
			DisplayName.SetDefault("Cosmic Cataclysm");
            item.damage = 1000;	
            item.melee = false;	
            item.useTime = 10;	
            item.useAnimation = 10;	
            item.useStyle = 1;
            item.noMelee = false;
            item.knockBack = 10;
            item.value = Item.buyPrice(1, 20, 50, 0);
            item.rare = 11;
            item.UseSound = SoundID.Item21;
            item.autoReuse = true;
			item.shoot = 0;
			item.useTurn = true;
		}

		public override void OnHitNPC(Player player, NPC target, int damage, float knockback, bool crit)
		{
			target.AddBuff(BuffID.Daybreak, 5 * 60);
			target.AddBuff(BuffID.Frostburn, 5 * 60);
			target.AddBuff(BuffID.DryadsWardDebuff, 5 * 60);

			int healingAmount = damage/50;
			player.statLife +=healingAmount;
			player.HealEffect(healingAmount, true);
		}

		public override bool AltFunctionUse(Player player)
		{
			return true;
		}

		public override bool CanUseItem(Player player)
		{
			if (player.altFunctionUse == 2)
			{
			item.useStyle = 1;
			DisplayName.SetDefault("Cosmic Cataclysm");
			item.useTime = 14;
            item.useAnimation = 14;
			item.UseSound = SoundID.Item1;
			item.damage = 1000;
			item.shoot = mod.ProjectileType("CataclysmicBlaze");
			item.shootSpeed = 16f;
			item.useTurn = true;
			}
			else
			{
			item.CloneDefaults(ItemID.StarWrath);
			DisplayName.SetDefault("Cosmic Cataclysm");
            item.damage = 1000;	
            item.melee = false;	
            item.useTime = 10;	
            item.useAnimation = 10;	
            item.useStyle = 1;
            item.noMelee = false;
            item.knockBack = 10;
            item.value = Item.buyPrice(1, 20, 50, 0);
            item.rare = 11;
            item.UseSound = SoundID.Item21;
            item.autoReuse = true;
			item.shoot = 0;
			item.useTurn = true;
			}
			return base.CanUseItem(player);
		}
 
        public override bool Shoot(Player player, ref Vector2 position, ref float speedX, ref float speedY, ref int type, ref int damage, ref float knockBack)
        {
            int numberProjectiles = 2 + Main.rand.Next(1);
            for (int index = 0; index < numberProjectiles; ++index)
            {
                Vector2 vector2_1 = new Vector2((float)((double)player.position.X + (double)player.width * 0.5 + (double)(Main.rand.Next(100) * -player.direction) + ((double)Main.mouseX + (double)Main.screenPosition.X - (double)player.position.X)), (float)((double)player.position.Y + (double)player.height * 0.5 - 600.0));   //This defines the projectile width, direction and position.
                vector2_1.X = (float)(((double)vector2_1.X + (double)player.Center.X) / 2.0) + (float)Main.rand.Next(-100, 100);
                vector2_1.Y -= (float)(100 * index);
                float num12 = (float)Main.mouseX + Main.screenPosition.X - vector2_1.X;
                float num13 = (float)Main.mouseY + Main.screenPosition.Y - vector2_1.Y;
                if ((double)num13 < 0.0) num13 *= -1f;
                if ((double)num13 < 20.0) num13 = 20f;
                float num14 = (float)Math.Sqrt((double)num12 * (double)num12 + (double)num13 * (double)num13);
                float num15 = item.shootSpeed / num14;
                float num16 = num12 * num15;
                float num17 = num13 * num15;
                float SpeedX = num16 + (float)Main.rand.Next(-12, 10) * 0.160f;  //This defines the projectile X position speed and randomness.
                float SpeedY = num17 + (float)Main.rand.Next(-12, 10) * 0.160f;  //This defines the projectile Y position speed and randomness.
                Projectile.NewProjectile(vector2_1.X, vector2_1.Y, SpeedX, SpeedY, type, damage, knockBack, Main.myPlayer, 0.0f, (float)Main.rand.Next(5));
				Projectile.NewProjectile(vector2_1.X, vector2_1.Y, SpeedX * 0.85f, SpeedY * 0.85f, mod.ProjectileType("CataclysmicFrost"), damage * 1, knockBack, Main.myPlayer, 0.0f, (float)Main.rand.Next(5)); //The "CataclysmicFrost" projectile's velocity is 85% of the original projectile's speed.
				Projectile.NewProjectile(vector2_1.X, vector2_1.Y, SpeedX * 1.50f, SpeedY * 1.50f, mod.ProjectileType("CataclysmicLife"), damage * 1, knockBack, Main.myPlayer, 0.0f, (float)Main.rand.Next(5)); //The "CataclysmicLife" projectile's velocity is 50%  more than the original projectile's speed.
            }
            return false;
        }
		
		public override void AddRecipes() //Cannot add more than 14 items in the recipe, including modded items.
		{
		ModRecipe recipe = new ModRecipe(mod);
		//Vanilla items in the recipe.
		recipe.AddIngredient(ItemID.StarWrath, 1);
		recipe.AddIngredient(ItemID.FragmentSolar, 20);
		recipe.AddIngredient(ItemID.FragmentVortex, 20);
		recipe.AddIngredient(ItemID.FragmentNebula, 20);
		recipe.AddIngredient(ItemID.FragmentStardust, 20);
		recipe.AddIngredient(ItemID.LunarBar, 20);
		recipe.AddIngredient(ItemID.HallowedBar, 20);
		recipe.AddIngredient(ItemID.SoulofLight, 50);
		recipe.AddIngredient(ItemID.SoulofNight, 50);
		recipe.AddIngredient(ItemID.BrokenHeroSword, 1);
		//Modded item in the recipe.
		recipe.AddIngredient(mod, "InfernalFury");
		recipe.AddIngredient(mod, "PrimordialBlizzard");
		recipe.AddIngredient(mod, "NaturesJudgement");
		//Workbench the item is crafted at.
		recipe.AddTile(TileID.LunarCraftingStation);
		recipe.SetResult(this, 1);
		recipe.AddRecipe();
		}
 
    }
}