using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using Terraria.ID;
using Terraria.ModLoader;
 
namespace JoshuasMod.Items.Weapons.ElementalSwords
{
	public class NaturesJudgement : ModItem
	{
		public override void SetDefaults()
		{
			item.useStyle = 1;    //The way your Weapon will be used, 1 is the regular sword swing.
			DisplayName.SetDefault("Nature's Judgement");
            item.UseSound = SoundID.Item1; //The sound played when using your Weapon.
			item.damage = 750;
			item.width = 80;    //The size of the width of the hitbox in pixels.
            item.height = 86;    //The size of the height of the hitbox in pixels.
			item.useTime = 12;   //How fast the Weapon is used.
            item.useAnimation = 12;     //How long the Weapon is used for.
			item.knockBack = 10;			//The force of knockback of the weapon. Maxium is 20.
			item.autoReuse = true;
			item.melee = false;
			item.rare = 11;
			item.useTurn = true;
		}

		public override void OnHitNPC(Player player, NPC target, int damage, float knockback, bool crit)
		{
			target.AddBuff(BuffID.DryadsWardDebuff, 300); //Add "DryadsWardDebuff" buff to the NPC for 5 seconds.
			target.AddBuff(BuffID.Venom, 300); //Add "Venom" buff to the NPC for 5 seconds.

			int healingAmount = damage/50; //Add "Life Stealing" abilty when the weapon hits an NPC.
			player.statLife +=healingAmount;
			player.HealEffect(healingAmount, true);
		}

		public override bool AltFunctionUse(Player player)
		{
			return true;
		}

		public override bool CanUseItem(Player player)
		{
			if (player.altFunctionUse == 2)
			{
			item.useStyle = 1;    //The way your Weapon will be used, 1 is the regular sword swing.
			DisplayName.SetDefault("Nature's Judgement");
			item.useTime = 14;   //How fast the Weapon is used.
            item.useAnimation = 14;     //How long the Weapon is used for.
			item.UseSound = SoundID.Item1;
			item.damage = 750;
			item.shoot = mod.ProjectileType("Boulder");
			item.shootSpeed = 20f;
			player.AddBuff(BuffID.DryadsWard, 59);		//Add "DryadsWard" buff to the Player
			}
			else
			{
			item.useStyle = 1;    //The way your Weapon will be used, 1 is the regular sword swing.
			DisplayName.SetDefault("Nature's Judgement");
            item.UseSound = SoundID.Item1; //The sound played when using your Weapon.
			item.damage = 750;
			item.useTime = 10;   //How fast the Weapon is used.
            item.useAnimation = 10;     //How long the Weapon is used for.
			item.autoReuse = true;
			item.melee = false;
			item.rare = 11;
			item.useTurn = true;
			item.shoot = 0;
			}
			return base.CanUseItem(player);
		}
		
		public override void AddRecipes() //Cannot add more than 14 items in the recipe, including modded items.
		{
		ModRecipe recipe = new ModRecipe(mod);
		//Vanilla items in the recipe.
		recipe.AddIngredient(ItemID.BladeofGrass, 1);
		recipe.AddIngredient(ItemID.Katana, 1);
		recipe.AddIngredient(ItemID.ChlorophyteBar, 20);
		recipe.AddIngredient(ItemID.LunarBar, 20);
		recipe.AddIngredient(ItemID.HallowedBar, 20);
		recipe.AddIngredient(ItemID.BrokenHeroSword, 1);
		//Workbench the item is crafted at.
		recipe.AddTile(TileID.LunarCraftingStation);
		recipe.SetResult(this, 1);
		recipe.AddRecipe();
		}

    }
}