using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using Terraria.ID;
using Terraria.ModLoader;
 
namespace JoshuasMod.Items.Weapons.Nirvana
{
	public class Nirvana : ModItem
	{
		public override void SetDefaults()
		{
			item.useStyle = 1;    //The way your Weapon will be used, 1 is the regular sword swing.
			DisplayName.SetDefault("Nirvana");
            item.UseSound = SoundID.Item1; //The sound played when using your Weapon.
			item.damage = 1000;
			item.width = 64;    //The size of the width of the hitbox in pixels.
            item.height = 70;    //The size of the height of the hitbox in pixels.
			item.useTime = 10;   //How fast the Weapon is used.
            item.useAnimation = 10;     //How long the Weapon is used for.
			item.autoReuse = true;
			item.melee = false;
			item.rare = 11;
			item.useTurn = true;
			}

		public override void OnHitNPC(Player player, NPC target, int damage, float knockback, bool crit)
		{
			target.AddBuff(BuffID.CursedInferno, 300);		//Add CursedInferno buff to the NPC for 5 seconds.

			int healingAmount = damage/50;
			player.statLife +=healingAmount;
			player.HealEffect(healingAmount, true);
		}
		
		public override bool AltFunctionUse(Player player)
		{
			return true;
		}

		public override bool CanUseItem(Player player)
		{
			if (player.altFunctionUse == 2)
			{
				item.useStyle = 1;
				DisplayName.SetDefault("Nirvana");
				item.UseSound = SoundID.Item1; //The sound played when using your Weapon.
				item.useTime = 14;
				item.useAnimation = 14;
				item.damage = 1000;
				item.shoot = mod.ProjectileType("NirvanaWave");
				item.shootSpeed = 20f;
				item.useTurn = true;
			}
			else
			{
				item.useStyle = 1;    //The way your Weapon will be used, 1 is the regular sword swing.
				DisplayName.SetDefault("Nirvana");
				item.UseSound = SoundID.Item1; //The sound played when using your Weapon.
				item.damage = 1000;
				item.useTime = 10;   //How fast the Weapon is used.
				item.useAnimation = 10;     //How long the Weapon is used for.
				item.autoReuse = true;
				item.melee = false;
				item.rare = 11;
				item.shoot = 0;
				item.useTurn = true;
			}
			return base.CanUseItem(player);
			
		}
          public override bool Shoot(Player player, ref Vector2 position, ref float speedX, ref float speedY, ref int type, ref int damage, ref float knockBack)
          {
              float numberProjectiles = 3; // This defines how many projectiles to shoot.
              float rotation = MathHelper.ToRadians(6);
              position += Vector2.Normalize(new Vector2(speedX, speedY)) * 6f; //this defines the distance of the projectiles from the player when the projectile spawns.
              for (int i = 0; i < numberProjectiles; i++)
              {
                  Vector2 perturbedSpeed = new Vector2(speedX, speedY).RotatedBy(MathHelper.Lerp(-rotation, rotation, i / (numberProjectiles - 1))) * 1f; // This defines the projectile roatation and speed. 1f == projectile speed.
                  Projectile.NewProjectile(position.X, position.Y, perturbedSpeed.X, perturbedSpeed.Y, type, damage, knockBack, player.whoAmI);
              }
              return false;
		  }
	}
}