using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using Terraria.ID;
using Terraria.ModLoader;

namespace JoshuasMod.Projectiles.ElementalSwords     //We need this to basically indicate the folder where it is to be read from, so you the texture will load correctly
{
    public class Boulder : ModProjectile
	{
		public override void SetDefaults()
		{
			projectile.CloneDefaults(ProjectileID.BoulderStaffOfEarth);
			projectile.width = 42;    //The size of the width of the hitbox in pixels.
            projectile.height = 42;    //The size of the height of the hitbox in pixels.
			projectile.penetrate = 8;
			projectile.tileCollide = true;
			projectile.ignoreWater = true;
			projectile.melee = true;
			aiType = ProjectileID.BoulderStaffOfEarth;
        }

        public override void OnHitNPC(NPC target, int damage, float knockback, bool crit)
        {
            target.AddBuff(BuffID.DryadsWardDebuff, 5 * 60);
			target.AddBuff(BuffID.Venom, 5 * 60);
        }
    }
}