using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using Terraria.ID;
using Terraria.ModLoader;

namespace JoshuasMod.Projectiles.Nirvana
{
    public class NirvanaWave : ModProjectile
	{
		public override void SetDefaults()
		{
			projectile.CloneDefaults(ProjectileID.TerrarianBeam);
			projectile.damage = 1000;
			projectile.width = 32;    //The size of the width of the hitbox in pixels.
            projectile.height = 80;    //The size of the height of the hitbox in pixels.
			projectile.penetrate = -1;
			projectile.tileCollide = false;
			projectile.ignoreWater = true;
			projectile.melee = true;
			aiType = ProjectileID.TerrarianBeam;
        }
        public override void AI()           //This makes it so that the projectile will face the correct way.
        {
            projectile.rotation = (float)Math.Atan2((double)projectile.velocity.Y, (double)projectile.velocity.X) + 1.75f;  
        }

        public override void OnHitNPC(NPC target, int damage, float knockback, bool crit)
        {
            target.AddBuff(BuffID.CursedInferno, 5 * 60);
        }
    }
}